
QGIS Application - Bug report #22006

Vertex tool not working on lines when style assigned

2019-05-06 07:55 PM - Peter Cornelissen

Status: Open

Priority: Normal

Assignee:

Category: Digitising

Affected QGIS version:3.6.2 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 29820

Description

I have a project with numerous layers. On a line or polygon shapefile layer without style, it woks fine, however, if I use the same shapefile

and it has style associated with it (once it has been saved), the vertex editor does not work. Reproducible on my project with all

shapefiles.

History

#1 - 2019-05-06 07:57 PM - Peter Cornelissen

Just to clarify, this is rule based styles/symbology

#2 - 2019-05-07 09:33 AM - Giovanni Manghi

- Status changed from Open to Feedback

Peter Cornelissen wrote:

I have a project with numerous layers. On a line or polygon shapefile layer without style, it woks fine, however, if I use the same shapefile and it has

style associated with it (once it has been saved), the vertex editor does not work. Reproducible on my project with all shapefiles.

I can't replicate here could you attach a sample project+data?

#3 - 2019-05-07 10:58 AM - Peter Cornelissen

- File 2018 excavations.qlr added

I've attached a LDF, hopefully that has all you need. I tried loading this into a new project and I still get the same problem.

#4 - 2019-05-07 11:08 AM - Peter Cornelissen

- File Bug issue.qlr added

Sorry, that's a bit over complicated, attached is a simplified version with the same shapefile but one with style the other without.

#5 - 2019-05-07 02:55 PM - Peter Cornelissen
- Status changed from Feedback to Open

#6 - 2019-05-09 09:26 AM - Giovanni Manghi

- Status changed from Open to Feedback

Peter Cornelissen wrote:

Sorry, that's a bit over complicated, attached is a simplified version with the same shapefile but one with style the other without.

hard to try replicate wothout the actual data, can you attach a simple project+sample data/style?

#7 - 2019-05-09 05:43 PM - Peter Cornelissen

- File NWW2016-2019.qgs.qgz added

- Assignee set to Giovanni Manghi

- File StyleUsingAttributes.qml added

- File StyleNOTUsingAttributes.qml added

- File Lines.shx added

- File Lines.shp added

- File Lines.qpj added

- File Lines.prj added

- File Lines.dbf added

- File Lines.cpg added

Hi

I've attached the necessary project files as requested, but what I have discovered by putting this example together is that it is the use of attributes in the

rule-based style that causes the problem. I use attributes as I repeat the style dozens of times in the various Plans and do not want to have to have to

create a different style file for each.

Thanks, Peter

#8 - 2019-05-09 05:43 PM - Peter Cornelissen

- Status changed from Feedback to Open

#9 - 2019-05-10 06:16 PM - Giovanni Manghi

- Assignee deleted (Giovanni Manghi)

#10 - 2019-05-10 06:21 PM - Giovanni Manghi

- Status changed from Open to Feedback

for some reason in your project the decimal separator in the vertex editor shows as "," even if is all set to english in my pc (so to use the "." instead).

Using a locale that uses commas as separator is known to make the editor not working, see:

https://issues.qgis.org/issues/21867
#11 - 2019-05-11 01:30 AM - Peter Cornelissen

- Status changed from Feedback to Open

If I understood this correctly, I had to change the QGIS locale by opening the Settings -> Options dialog and in the General tab 'Override system locale' and

select English United Kingdom. I made the change, restarted QGIS. If that's the case, as far as I can tell the error is still there. Works fine without the

attributes, but not with them. If there is anything else I am supposed to change, please let me know.

#12 - 2019-05-11 05:30 PM - Giovanni Manghi

- Status changed from Open to Feedback

Peter Cornelissen wrote:

If I understood this correctly, I had to change the QGIS locale by opening the Settings -> Options dialog and in the General tab 'Override system

locale' and select English United Kingdom. I made the change, restarted QGIS. If that's the case, as far as I can tell the error is still there. Works fine

without the attributes, but not with them. If there is anything else I am supposed to change, please let me know.

do you still the comma as decimal separator in the vertex editor?

#13 - 2019-05-11 08:28 PM - Peter Cornelissen

- File vertex editor.jpg added

- Status changed from Feedback to Open

Sorry, I should have checked before, but the decimal separator is '.' (see attached) and as I hadn't checked before making the change, I reverted to system

locale and that is also '.' (i.e. no sign of a comma). As I can't get the tool or editor to work on the style with attributes, I can't obviously see what the result is

there. Unfortunately, I don't think this issue is not related to the system locale issue, it must be something to do with the use of the attribute in the style rule

expression.

#14 - 2019-05-11 08:39 PM - Peter Cornelissen

Something else that may be significant I have just discovered is that if I add a new line using the 'Add Line Feature' tool, to the same layer which is using

the attribute style, I can use the vertex editor on that new line, but only until I save and close the project. Once I do that and open it again, I can no longer

edit the line.

#15 - 2019-05-13 12:21 AM - Giovanni Manghi

Peter Cornelissen wrote:

Sorry, I should have checked before, but the decimal separator is '.' (see attached) and as I hadn't checked before making the change, I reverted to

system locale and that is also '.' (i.e. no sign of a comma). As I can't get the tool or editor to work on the style with attributes, I can't obviously see

what the result is there. Unfortunately, I don't think this issue is not related to the system locale issue, it must be something to do with the use of the

attribute in the style rule expression.

on a clean/new qgis profile I can edit your project/lines with the vertex editor without issues, please give it a try.
#16 - 2019-05-13 09:33 AM - Peter Cornelissen

I have now tried that and unfortunately, on the style using attributes, I still cannot edit the vertex.

Files

2018 excavations.qlr 4.39 MB 2019-05-07 Peter Cornelissen

Bug issue.qlr 455 KB 2019-05-07 Peter Cornelissen

Lines.cpg 5 Bytes 2019-05-09 Peter Cornelissen

Lines.dbf 18 KB 2019-05-09 Peter Cornelissen

Lines.prj 417 Bytes 2019-05-09 Peter Cornelissen

Lines.qpj 690 Bytes 2019-05-09 Peter Cornelissen

Lines.shp 57.9 KB 2019-05-09 Peter Cornelissen

Lines.shx 2.05 KB 2019-05-09 Peter Cornelissen

NWW2016-2019.qgs.qgz 10.9 KB 2019-05-09 Peter Cornelissen

StyleUsingAttributes.qml 27.2 KB 2019-05-09 Peter Cornelissen

StyleNOTUsingAttributes.qml 27.1 KB 2019-05-09 Peter Cornelissen

vertex editor.jpg 21.1 KB 2019-05-11 Peter Cornelissen
